import functools

from typing import List

from ._ec2 import create_records, paging_request
from .records import EC2NetworkInterface, EC2NetworkInterfaceData
from ..records import AWSClient
from .._api import client


ec2_client = functools.partial(client, endpoint="ec2")
creator = functools.partial(create_records, EC2NetworkInterfaceData)
data_key = "NetworkInterfaces"


def get_all(aws_client: AWSClient, region_name: str) -> List[EC2NetworkInterface]:
    return creator(
        paging_request(ec2_client(aws_client=aws_client, region_name=region_name).describe_network_interfaces, data_key)
    )
